/*
 * Fernando Pereira Silveira
 */

const prefsCount = 14;

var prefID = new Array(prefsCount);
prefID[0]  = "controledescripts-move_resize";
prefID[1]  = "controledescripts-flip";
prefID[2]  = "controledescripts-contextmenu";
prefID[3]  = "controledescripts-status";
prefID[4]  = "controledescripts-status_change";
prefID[5]  = "controledescripts-image";
prefID[6]  = "controledescripts-close_windows";
prefID[7]  = "controledescripts-resizable";
prefID[8]  = "controledescripts-menubar";
prefID[9]  = "controledescripts-toolbar";
prefID[10] = "controledescripts-location";
prefID[11] = "controledescripts-directories";
prefID[12] = "controledescripts-scrollbars";
prefID[13] = "controledescripts-ocultarmenu";

var boolPref = new Array(prefsCount);
boolPref[0]  = "dom.disable_window_move_resize";
boolPref[1]  = "dom.disable_window_flip";
boolPref[2]  = "dom.event.contextmenu.enabled";
boolPref[3]  = "dom.disable_window_open_feature.status";
boolPref[4]  = "dom.disable_window_status_change";
boolPref[5]  = "dom.disable_image_src_set";
boolPref[6]  = "dom.allow_scripts_to_close_windows";
boolPref[7]  = "dom.disable_window_open_feature.resizable";
boolPref[8]  = "dom.disable_window_open_feature.menubar";
boolPref[9]  = "dom.disable_window_open_feature.toolbar";
boolPref[10] = "dom.disable_window_open_feature.location";
boolPref[11] = "dom.disable_window_open_feature.directories";
boolPref[12] = "dom.disable_window_open_feature.scrollbars";
boolPref[13] = "controledescripts.ocultarmenu";

var listID = "controledescripts-listaeventos-permitidos";
var listPref = "dom.popup_allowed_events";
var listaEventos;
var tamanhoAnterior;
var eventoSelecionadoD;
var eventoSelecionadoP;

function controledescripts_adicionar_evento()
{
	if (eventoSelecionadoD)
	{
		eventoSelecionadoD = eventoSelecionadoD.toLowerCase();

		var estaNaLista = false;

		for (var indice in listaEventos)
			if (listaEventos[indice] == eventoSelecionadoD)
			{
				estaNaLista = true;
				break;
			}

		if (!estaNaLista)
		{
			listaEventos.push(eventoSelecionadoD);
			listaEventos = listaEventos.sort();

			controledescripts_recarregar_eventos();
		}
		else
			alert(document.getElementById("controledescripts-prefs-strings").getString("controledescripts.alreadyOnList"));
	}
}

function controledescripts_atualizar_botoes()
{
	var botaoAdicionar = document.getElementById("controledescripts-eventos-adicionar");
	var botaoRemover = document.getElementById("controledescripts-eventos-remover");

	if (eventoSelecionadoD)
		botaoAdicionar.disabled = false;
	else
		botaoAdicionar.disabled = true;

	if (eventoSelecionadoP)
		botaoRemover.disabled = false;
	else
		botaoRemover.disabled = true;
}

function controledescripts_atualizar_evento(lista,listaDisponiveis)
{
	if (listaDisponiveis)
		eventoSelecionadoD = lista.selectedItem.getAttribute("label");
	else
		eventoSelecionadoP = lista.selectedItem.getAttribute("label");

	controledescripts_atualizar_botoes();
}

function controledescripts_carregar_prefs()
{
	for (var indice in boolPref)
	{
		if (indice==2||indice==6||indice==13)
		{
			try {document.getElementById(prefID[indice]).checked =  nsPreferences.getBoolPref(boolPref[indice]);}
			catch (e) {}
		}
		else
		{
			try {document.getElementById(prefID[indice]).checked = !nsPreferences.getBoolPref(boolPref[indice]);}
			catch (e) {}
		}
	}

	listaEventos = nsPreferences.copyUnicharPref(listPref).split(" ")
	tamanhoAnterior = listaEventos.length;

	for (var indice in listaEventos)
		document.getElementById(listID).appendItem(listaEventos[indice]);

	controledescripts_atualizar_botoes();
}

function controledescripts_recarregar_eventos()
{
	var lista = document.getElementById(listID);

	for (var indice=0; indice<tamanhoAnterior; indice++)
		if (lista.hasChildNodes)
			lista.removeChild(lista.lastChild);

	for (var indice in listaEventos)
		lista.appendItem(listaEventos[indice]);

	tamanhoAnterior = listaEventos.length;
	eventoSelecionadoP = null;
	controledescripts_atualizar_botoes();
}

function controledescripts_remover_evento()
{
	var indice;

	if (eventoSelecionadoP)
	{
		for (indice in listaEventos)
			if (listaEventos[indice] == eventoSelecionadoP)
				break;

		listaEventos.splice(indice,1);

		controledescripts_recarregar_eventos();
	}
}

function controledescripts_salvar_prefs()
{
	for (var indice in boolPref)
	{
		if (indice==2||indice==6||indice==13)
			nsPreferences.setBoolPref(boolPref[indice], document.getElementById(prefID[indice]).checked);
		else
			nsPreferences.setBoolPref(boolPref[indice],!document.getElementById(prefID[indice]).checked);
	}

	nsPreferences.setUnicharPref(listPref,listaEventos.join(" "));
}
